<?php
/*
Copyright: © 2009 WebSharks, Inc. ( coded in the USA )
<mailto:support@websharks-inc.com> <http://www.websharks-inc.com/>

Released under the terms of the GNU General Public License.
You should have received a copy of the GNU General Public License,
along with this software. In the main directory, see: /licensing/
If not, see: <http://www.gnu.org/licenses/>.
*/
/*
Direct access denial.
*/
if (realpath(__FILE__) === realpath($_SERVER["SCRIPT_FILENAME"]))
	exit;
/*
This is the function for registering the widget.
Attach to: add_action("widgets_init");
*/
function ws_widget__super_tags_register ()
	{
		register_widget("ws_widget__super_tags");
		/**/
		return;
	}
/*
The extended WP_Widget class that handles several things.
*/
class ws_widget__super_tags /* < Register this widget class. */
	extends WP_Widget /* See: /wp-includes/widgets.php for further details. */
	{
		/*
		Constructor function.
		*/
		function ws_widget__super_tags () /* Builds the classname, id_base, description, etc. */
			{
				$widget_ops = array("classname" => "super-tags widget_tag_cloud", "description" => $GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["description"]);
				$control_ops = array("width" => $GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["control_w"], "id_base" => "ws_widget__super_tags");
				$this->WP_Widget($control_ops["id_base"], $GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["name"], $widget_ops, $control_ops);
				/**/
				return;
			}
		/*
		Widget display function. This is where the widget actually does something.
		*/
		function widget ($args = FALSE, $instance = FALSE)
			{
				$options = ws_widget__super_tags_configure_options_and_their_defaults(false, (array)$instance);
				/**/
				echo $args["before_widget"]; /* Ok, here we go into this widget.
				/**/
				if (strlen($options["title"])) /* If there is. */
					echo $args["before_title"] . apply_filters("widget_title", $options["title"]) . $args["after_title"];
				/**/
				echo wp_tag_cloud($options); /* Pass options to the wp_tag_cloud function. */
				/**/
				echo $args["after_widget"];
				/**/
				return;
			}
		/*
		Widget form control function. This is where options are made configurable.
		*/
		function form ($instance = FALSE)
			{
				$options = ws_widget__super_tags_configure_options_and_their_defaults(false, (array)$instance);
				/*
				Ok, here is where we need to handle the widget control form. This allows a user to further customize the widget.
				*/
				echo '<label for="' . $this->get_field_id("title") . '">Title:</label><br />' . "\n";
				echo '<input class="widefat" id = "' . $this->get_field_id("title") . '" name = "' . $this->get_field_name("title") . '" type = "text" value = "' . format_to_edit($options["title"]) . '" /><br /><br />' . "\n";
				/**/
				echo '<label for="' . $this->get_field_id("smallest") . '">Smallest Font Size ( optional / in pixels ):</label><br />' . "\n";
				echo '<input class="widefat" id = "' . $this->get_field_id("smallest") . '" name = "' . $this->get_field_name("smallest") . '" type = "text" value = "' . format_to_edit($options["smallest"]) . '" /><br /><br />' . "\n";
				/**/
				echo '<label for="' . $this->get_field_id("largest") . '">Largest Font Size ( optional / in pixels ):</label><br />' . "\n";
				echo '<input class="widefat" id = "' . $this->get_field_id("largest") . '" name = "' . $this->get_field_name("largest") . '" type = "text" value = "' . format_to_edit($options["largest"]) . '" /><br /><br />' . "\n";
				/**/
				echo '<label for="' . $this->get_field_id("number") . '">Max Tags To Display ( optional / number > 1 ):</label><br />' . "\n";
				echo '<input class="widefat" id = "' . $this->get_field_id("number") . '" name = "' . $this->get_field_name("number") . '" type = "text" value = "' . format_to_edit($options["number"]) . '" /><br /><br />' . "\n";
				/**/
				echo '<label for="' . $this->get_field_id("format") . '">Format ( optional / flat or list ):</label><br />' . "\n";
				echo '<input class="widefat" id = "' . $this->get_field_id("format") . '" name = "' . $this->get_field_name("format") . '" type = "text" value = "' . format_to_edit($options["format"]) . '" /><br /><br />' . "\n";
				/**/
				echo '<label for="' . $this->get_field_id("orderby") . '">Orderby ( optional / name or count ):</label><br />' . "\n";
				echo '<input class="widefat" id = "' . $this->get_field_id("orderby") . '" name = "' . $this->get_field_name("orderby") . '" type = "text" value = "' . format_to_edit($options["orderby"]) . '" /><br /><br />' . "\n";
				/**/
				echo '<label for="' . $this->get_field_id("order") . '">Order ( optional / ASC, DESC, or RAND ):</label><br />' . "\n";
				echo '<input class="widefat" id = "' . $this->get_field_id("order") . '" name = "' . $this->get_field_name("order") . '" type = "text" value = "' . format_to_edit($options["order"]) . '" /><br /><br />' . "\n";
				/**/
				echo '<label for="' . $this->get_field_id("exclude") . '">Exclude ( optional / comma separated term IDs ):</label><br />' . "\n";
				echo '<input class="widefat" id = "' . $this->get_field_id("exclude") . '" name = "' . $this->get_field_name("exclude") . '" type = "text" value = "' . format_to_edit($options["exclude"]) . '" /><br /><br />' . "\n";
				/**/
				echo '<label for="' . $this->get_field_id("include") . '">Include ( optional / comma separated term IDs ):</label><br />' . "\n";
				echo '<input class="widefat" id = "' . $this->get_field_id("include") . '" name = "' . $this->get_field_name("include") . '" type = "text" value = "' . format_to_edit($options["include"]) . '" /><br /><br />' . "\n";
				/**/
				echo '<label for="' . $this->get_field_id("taxonomy") . '">Taxonomy ( optional / post_tag, category, or link_category ):</label><br />' . "\n";
				echo '<input class="widefat" id = "' . $this->get_field_id("taxonomy") . '" name = "' . $this->get_field_name("taxonomy") . '" type = "text" value = "' . format_to_edit($options["taxonomy"]) . '" /><br /><br />' . "\n";
				/**/
				echo 'For additional help with these parameters, please read the documentation for the <code><a href="http://codex.wordpress.org/Template_Tags/wp_tag_cloud" target="_blank">wp_tag_cloud() function</a></code>.';
				/**/
				echo '<br />' . "\n";
				/**/
				return;
			}
		/*
		Widget update function. This is where an updated instance is configured/stored.
		*/
		function update ($instance = FALSE, $old = FALSE)
			{
				return ws_widget__super_tags_configure_options_and_their_defaults(false, (array)$instance);
			}
	}
?>