<?php
/*
Copyright: © 2009 WebSharks, Inc. ( coded in the USA )
<mailto:support@websharks-inc.com> <http://www.websharks-inc.com/>

Released under the terms of the GNU General Public License.
You should have received a copy of the GNU General Public License,
along with this software. In the main directory, see: /licensing/
If not, see: <http://www.gnu.org/licenses/>.
*/
/*
WARNING: This is a system configuration file, please DO NOT EDIT this file directly!
... Instead, use the widget options panel in WordPress® to override these settings.
*/
/*
Direct access denial.
*/
if (realpath (__FILE__) === realpath ($_SERVER["SCRIPT_FILENAME"]))
	exit;
/*
Detect if we are inside an MU installation.
*/
if (($GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["is_wpmu"] = function_exists ("wpmu_current_site"))/**/
&& (file_exists (dirname (dirname (__FILE__)) . "/wpmu.farm") || file_exists (TEMPLATEPATH . "/wpmu.farm")))
	$GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["is_wpmu_farm"] = true; /* Requires /wpmu.farm file. */
/*
Configure important global values for this widget + default values for options.
*/
$GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["name"] = "Super Tags";
$GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["control_w"] = "400"; /* Width of the control box. */
$GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["description"] = "Highly customizable tag cloud for WordPress®.";
/*
Determine the full url to the directory this plugin resides in.
*/
$GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["dir_url"] = WP_CONTENT_URL . /* URL to the plugin directory. */
preg_replace ("/^(.*?)(\/" . preg_quote (basename (WP_CONTENT_DIR), "/") . ")/", "", dirname (dirname (__FILE__)));
/*
Check if the plugin has been configured *should be set after the first config via options panel*.
*/
$GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["configured"] = get_option ("ws_widget__super_tags_configured");
/*
Configure the right menu options panel for this software.
*/
$GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["menu-r"] = array ("tools" => true, "tips" => false, "donations" => true);
/*
Configure the file modification time for the syscon.inc.php file.
*/
$GLOBALS["WS_WIDGET__"]["super_tags"]["c"]["filemtime"] = filemtime (__FILE__);
/*
Configure & validate all of the widget options; and set their defaults.
*/
function ws_widget__super_tags_configure_options_and_their_defaults ($options = FALSE, $per_widget_options = FALSE)
	{
		/*
		Here we build the default options array, which will be merged with the user options.
		It is important to note that sometimes default options may not or should not be pre-filled on an options form.
		These defaults are for the system to use in various ways, we may choose not to pre-fill certain fields.
		In other words, some defaults may be used internally, but to the user, the option will be empty. */
		$default_options = array ( /* Please comment each line for clarity, it is easy to forget things. */
		/**/
		"options_version" => "1.0", /* Used internally to keep runtime files up-to-date. */
		/**/
		"run_deactivation_routines" => "1"); /* Should deactivation routines be processed? */
		/*
		We also build the default widget options array, these get merged on a per-widget basis.
		It is important to note that sometimes default options may not or should not be pre-filled on an options form.
		These defaults are for the system to use in various ways, we may choose not to pre-fill certain fields.
		In other words, some defaults may be used internally, but to the user, the option will be empty. */
		$default_per_widget_options = array ( /* Defaults for widgets, on a per-widget basis. */
		/**/
		"title" => "Super Tags Widget", /* Ok for this particular option to be empty. */
		/**/
		"smallest" => "13", /* The text size of the tag with the smallest count value (units given by unit parameter). */
		"largest" => "20", /* The text size of the tag with the highest count value (units given by the unit parameter). */
		"unit" => "px", /* Unit of measure as pertains to the smallest and largest values. This can be any CSS length value, e.g. pt, px, em, %; default is pt (points). */
		"number" => "20", /* The number of actual tags to display in the cloud. (Use '0' to display all tags.) */
		"format" => "flat", /* Format of the cloud display. This can be flat or list.  */
		"orderby" => "name", /* Order of the tags. This can be name or count. */
		"order" => "RAND", /* Sort order. This can be ASC DESC or RAND. */
		"exclude" => "", /* Comma separated list of term_id's to exclude. */
		"include" => "", /* Comma separated list of term_id's to include. */
		"link" => "view", /* Set link to allow edit of a particular tag. */
		"taxonomy" => "post_tag"); /* This can be post_tag, category, or link_category. */
		/*
		Are we dealing with per-widget options here? 
		*/
		if ($per_widget_options !== false): /* If so we need to work differently. */
			/*
			Here they are merged. user options will overwrite some or all defaults. 
			*/
			$WS_WIDGET__per_widget_options = array_merge ($default_per_widget_options, (array)$per_widget_options);
			/*
			Validate each option, possibly reverting back to default if invalid.
			*/
			foreach ($WS_WIDGET__per_widget_options as $key => &$value)
				{
					if (!is_array ($value))
						$value = trim (stripslashes ($value));
					else /* A string, or an array of strings. */
						foreach ($value as $k => $v)
							$value[$k] = trim (stripslashes ($v));
					/**/
					if (!isset ($default_per_widget_options[$key]))
						unset ($WS_WIDGET__per_widget_options[$key]);
					/**/
					else if ($key === "title" && !is_string ($value))
						$value = $default_per_widget_options[$key]; /* Can be empty. */
					/**/
					else if ($key === "smallest" && (!is_string ($value) || !is_numeric ($value) || $value < 1))
						$value = $default_per_widget_options[$key]; /* Must be >= 1. */
					/**/
					else if ($key === "largest" && (!is_string ($value) || !is_numeric ($value) || $value < 1))
						$value = $default_per_widget_options[$key]; /* Must be >= 1. */
					/**/
					else if ($key === "unit" && (!is_string ($value) || !preg_match ("/^(pt|px|em|%)$/i", $value)))
						$value = $default_per_widget_options[$key]; /* Must be css compatible. */
					/**/
					else if ($key === "number" && (!is_string ($value) || !is_numeric ($value) || $value < 1))
						$value = $default_per_widget_options[$key]; /* Must be >= 1. */
					/**/
					else if ($key === "format" && (!is_string ($value) || !preg_match ("/^(flat|list)$/i", $value)))
						$value = $default_per_widget_options[$key]; /* Must be flat or list. */
					/**/
					else if ($key === "orderby" && (!is_string ($value) || !preg_match ("/^(name|count)$/i", $value)))
						$value = $default_per_widget_options[$key]; /* Must be name or count. */
					/**/
					else if ($key === "order" && (!is_string ($value) || !preg_match ("/^(ASC|DESC|RAND)$/i", $value)))
						$value = $default_per_widget_options[$key]; /* Must be sql compatible. */
					/**/
					else if ($key === "exclude" && (!is_string ($value) || !is_string ($value = preg_replace ("/[^0-9,]/", "", $value))))
						$value = $default_per_widget_options[$key]; /* This can be empty. */
					/**/
					else if ($key === "include" && (!is_string ($value) || !is_string ($value = preg_replace ("/[^0-9,]/", "", $value))))
						$value = $default_per_widget_options[$key]; /* This can be empty. */
					/**/
					else if ($key === "link" && (!is_string ($value) || !preg_match ("/^(view|edit)$/i", $value)))
						$value = $default_per_widget_options[$key]; /* Must be view or edit. */
					/**/
					else if ($key === "taxonomy" && (!is_string ($value) || !preg_match ("/^(post_tag|category|link_category)$/i", $value)))
						$value = $default_per_widget_options[$key]; /* Must be post_tag, category, or link_category. */
				}
			/**/
			return $WS_WIDGET__per_widget_options;
		/*
		Else we are dealing with the main plugin option configuration or validation. 
		*/
		else: /* We need to validate these while checking to see if options were passed in. */
			/*
			Here they are merged. user options will overwrite some or all defaults. 
			*/
			$GLOBALS["WS_WIDGET__"]["super_tags"]["o"] = array_merge ($default_options, (($options !== false) ? (array)$options : (array)get_option ("ws_widget__super_tags_options")));
			/*
			Validate each option, possibly reverting back to default if invalid.
			*/
			foreach ($GLOBALS["WS_WIDGET__"]["super_tags"]["o"] as $key => &$value)
				{
					if (!is_array ($value))
						$value = trim (stripslashes ($value));
					else /* A string, or an array of strings. */
						foreach ($value as $k => $v)
							$value[$k] = trim (stripslashes ($v));
					/**/
					if (!isset ($default_options[$key]))
						unset ($GLOBALS["WS_WIDGET__"]["super_tags"]["o"][$key]);
					/**/
					else if ($key === "options_version" && (!is_string ($value) || !is_numeric ($value)))
						$value = $default_options[$key];
					/**/
					else if ($key === "run_deactivation_routines" && (!is_string ($value) || !is_numeric ($value)))
						$value = $default_options[$key];
				}
			/**/
			return $GLOBALS["WS_WIDGET__"]["super_tags"]["o"];
		/**/
		endif;
	}
/*
Now lets call the function.
*/
call_user_func ("ws_widget__super_tags_configure_options_and_their_defaults");
?>